// GPRS library example
// by Industrial Shields

#include <GPRS.h>

#define PIN "3112"
#define APN "internet"
#define USERNAME ""
#define PASSWORD ""

uint8_t buffer[1024];

////////////////////////////////////////////////////////////////////////////////////////////////////
void setup() {
  Serial.begin(9600UL);

  if (!GPRS.begin(80)) {
    Serial.println("Impossible to begin GPRS");
    while(true);
  }

  int pinRequired = GPRS.isPINRequired();
  if (pinRequired == 1) {
    if (!GPRS.unlockSIM(PIN)) {
      Serial.println("Invalid PIN");
      while (true);
    }
  } else if (pinRequired != 0) {
    Serial.println("Blocked SIM");
    while (true);
  }
}

////////////////////////////////////////////////////////////////////////////////////////////////////
void loop() {
  static uint32_t lastStatusTime = millis();
  if (millis() - lastStatusTime > 2000) {
    GPRSClient client = GPRS.available();
    if (client) {
      size_t len = client.available();
      if (len > 0) {
        client.read(buffer, len);

        Serial.write(buffer, len);
      }
    }
  }
}
